// autom3u.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[]);
bool getListDirFiles(std::list<std::string> *pListDirMp3Files, const char *szDirPath);
HRESULT createLink(LPCSTR lpszPathObj, LPCSTR lpszPathLink, LPCSTR lpszDesc);

int main(int argc, char* argv[])
{
	printf("auto m3u v1.3 quick hack by Leo Davidson\n\n");

	HRESULT hr = CoInitialize(NULL);

	if (SUCCEEDED(hr))
	{
		struct _finddata_t fileinfo;
		long fr = _findfirst("*.*", &fileinfo);

		if ((-1) != fr)
		{
			do
			{
				if (fileinfo.attrib & _A_SUBDIR)
				{
					if (strcmp(".", fileinfo.name) && strcmp("..", fileinfo.name))
					{
						std::list<std::string> listDirMp3Files;

						if (getListDirFiles(&listDirMp3Files, fileinfo.name))
						{
							listDirMp3Files.sort();

							std::string strOutFilePath = fileinfo.name;
							strOutFilePath += "/";
							strOutFilePath += fileinfo.name;
							strOutFilePath += ".m3u";

							FILE *outFile = fopen(strOutFilePath.c_str(), "w");

							if (NULL == outFile)
							{
								printf("*** ERROR opening %s\n", strOutFilePath.c_str());
							}
							else
							{
								printf("Generating %s\n", strOutFilePath.c_str());

								fprintf(outFile, "#EXTM3U\n");

								for (std::list<std::string>::iterator liter = listDirMp3Files.begin(); liter != listDirMp3Files.end(); liter++)
								{
									fprintf(outFile, "%s\n", liter->c_str());
								}

								fclose(outFile);

								std::string strLinkPath = fileinfo.name;
								strLinkPath += ".lnk";

								char szFullM3uPath[_MAX_PATH + 1];
								
								if (NULL == _fullpath(szFullM3uPath, strOutFilePath.c_str(), _MAX_PATH))
								{
									printf("*** ERROR generating full path to %s\n", strOutFilePath.c_str());
								}
								else
								{
									HRESULT hr = createLink(szFullM3uPath, strLinkPath.c_str(), fileinfo.name);

									if (!SUCCEEDED(hr))
									{
										printf("*** ERROR generating shortcut to %s\n", strOutFilePath.c_str());
									}
								}
							}
						}
					}
				}

			} while (0 == _findnext(fr, &fileinfo));

			_findclose(fr);
		}

		CoUninitialize();
	}

	return 0;
}


bool getListDirFiles(std::list<std::string> *pListDirMp3Files, const char *szDirPath)
{
	bool bResult = false;

	std::string strSearchPath = szDirPath;
	strSearchPath += "/*.*";

	struct _finddata_t fileinfo;
	long fr = _findfirst(strSearchPath.c_str(), &fileinfo);

	if ((-1) != fr)
	{
		bool bFoundMp3 = false;
		bool bFoundM3u = false;

		do
		{
			if (!(fileinfo.attrib & _A_SUBDIR))
			{
				const char *szExt = strrchr(fileinfo.name, '.');

				if (NULL != szExt)
				{
					if (0 == stricmp(szExt, ".mp3")
					||	0 == stricmp(szExt, ".ogg")
					||	0 == stricmp(szExt, ".flac")
					||	0 == stricmp(szExt, ".wma")
					||	0 == stricmp(szExt, ".aac")
					||	0 == stricmp(szExt, ".mp4")
					||	0 == stricmp(szExt, ".shn")
					||	0 == stricmp(szExt, ".mp2"))
					{
						pListDirMp3Files->push_back(fileinfo.name);
						bFoundMp3 = true;
					}
					else if (0 == stricmp(szExt, ".m3u"))
					{
						bFoundM3u = true;
						break;
					}

				}
			}

		} while (0 == _findnext(fr, &fileinfo));

		_findclose(fr);

		if (bFoundMp3 && (!bFoundM3u))
		{
			bResult = true;
		}
	}

	return(bResult);
}

// Sample MSDN code which does the trick.
HRESULT createLink(LPCSTR lpszPathObj, LPCSTR lpszPathLink, LPCSTR lpszDesc)
{ 
    IShellLink *psl; 
 
    // Get a pointer to the IShellLink interface. 
    HRESULT hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *) &psl); 

    if (SUCCEEDED(hres))
	{ 
        IPersistFile* ppf; 
 
        // Set the path to the shortcut target and add the 
        // description. 
        psl->SetPath(lpszPathObj); 
        psl->SetDescription(lpszDesc); 
 
        // Query IShellLink for the IPersistFile interface for saving the 
        // shortcut in persistent storage. 
        hres = psl->QueryInterface(IID_IPersistFile, (void**)&ppf); 
 
        if (SUCCEEDED(hres))
		{ 
            WCHAR wsz[MAX_PATH]; 
 
            // Ensure that the string is Unicode. 
            MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH); 
 
            // Save the link by calling IPersistFile::Save. 
            hres = ppf->Save(wsz, TRUE); 
            ppf->Release(); 
        } 

        psl->Release(); 
    } 

    return hres; 
} 
